package cn.com.infosec.crypto.generators;

import cn.com.infosec.crypto.CipherParameters;
import cn.com.infosec.crypto.params.ParametersWithRandom;
import cn.com.infosec.crypto.params.RSAKeyParameters;
import cn.com.infosec.crypto.params.RSAPrivateCrtKeyParameters;
import java.math.BigInteger;
import java.security.SecureRandom;

public class RSABlindingFactorGenerator {
   private static BigInteger ZERO = BigInteger.valueOf(0L);
   private static BigInteger ONE = BigInteger.valueOf(1L);
   private RSAKeyParameters key;
   private SecureRandom random;

   public void init(CipherParameters param) {
      if (param instanceof ParametersWithRandom) {
         ParametersWithRandom param1;
         this.key = (RSAKeyParameters)(param1 = (ParametersWithRandom)param).getParameters();
         this.random = param1.getRandom();
      } else {
         this.key = (RSAKeyParameters)param;
         this.random = new SecureRandom();
      }

      if (this.key instanceof RSAPrivateCrtKeyParameters) {
         throw new IllegalArgumentException("generator requires RSA public key");
      }
   }

   public BigInteger generateBlindingFactor() {
      RSAKeyParameters var1;
      if ((var1 = this.key) == null) {
         throw new IllegalStateException("generator not initialised");
      } else {
         BigInteger var5;
         int var2 = (var5 = var1.getModulus()).bitLength() - 1;

         BigInteger var10000;
         BigInteger var3;
         BigInteger var4;
         do {
            do {
               var10000 = var3 = new BigInteger;
               var3.<init>(var2, this.random);
               var4 = var10000.gcd(var5);
            } while(var10000.equals(ZERO));
         } while(var3.equals(ONE) || !var4.equals(ONE));

         return var3;
      }
   }
}
